
import jnios.*;

import Reflecter.*;

import java.lang.reflect.*;


public class sigactionTest
{



	public static void handler2(int no)
	{
		posix.print("Hello! This is handler2() no=" + no + " in JavaVM(^ ^)\n");
	
	}


	public void handler(int no)
	{


		posix.print("Hello! This is handler() no=" + no + " in JavaVM(^ ^)\n");

	
	}


	public void test()
	{
		final long SIGINT 	= 2;
		final long SIGTSTP	= 18;
		final long SA_RESTART	= 268435456;


		
		Object[] sigaction_t = new Object[5];
		sigaction_t[0] = (Object)this.getClass();

		Class[] params = { Integer.TYPE };
		sigaction_t[1] = (Object)ReflecterTools.getMethod( "sigactionTest", "handler", params );
		sigaction_t[2] = (Object)this;


		long[] sigmask = { SIGTSTP };

		sigaction_t[3] = (Object)sigmask;
		sigaction_t[4] = (Object)new Long(SA_RESTART);
		

		Object[] old_act = new Object[5];
		
		posix.sigaction(SIGINT, sigaction_t, old_act);
		


		/*
		Class[] params = { Integer.TYPE };
		boolean[] sa_mask = posix.signalToBooleanArr(SIGTSTP);
		Long sa_flags= SA_RESTART;
		Method method = ReflecterTools.getMethod( "sigactionTest", "handler", params );
		posix.sigaction(SIGINT, this.getClass(), method, (Object)this, sa_mask, sa_flags );
		*/


		/*
		Class[] params = { Integer.TYPE };
		Long sa_mask = SIGTSTP;
		Long sa_flags= SA_RESTART;
		Method method = ReflecterTools.getMethod( "sigactionTest", "handler", params );
		posix.sigaction(SIGINT, this.getClass(), method, (Object)this, sa_mask, sa_flags );
		*/


		while( true )
		{
			posix.print( "read wait..\n");

			byte[] buf = new byte[256];
			long ret = posix.read( 0, buf);

			if ( ret >= 0)
			{
				
				byte[] cp_buf = new byte[ (int)ret ];
				System.arraycopy( buf, 0, cp_buf, 0, (int)ret );
				posix.write(1, cp_buf);
			}
		}

		// return ;
	}

	public static void main(String[] args)
	{

		sigactionTest st = new sigactionTest();
		st.test();

	}
}
