/*
 * Copyright 1999 Finn Bock.
 * Permission to use, copy and distribute this software is hereby granted, 
 * provided that the above copyright notice appear in all copies and that 
 * both that copyright notice and this permission notice appear.
 * 
 * No Warranty
 * The software is provided "as is" without warranty of any kind.
 * 
 * If you have questions regarding this software, contact:
 *    Finn Bock, bckfnn@pipmail.dknet.dk
 * 
 * This program contains material copyrighted by:
 * Copyright 1991-1995 by Stichting Mathematisch Centrum, Amsterdam,
 * The Netherlands.
 *
 */

package jnios;

import org.python.core.*;

public class os implements InitModule {
    public void initModule(PyObject dict) {
	dict.__delitem__("initModule");

	String modname = posix.getName().intern();

	// hack the sys.builtin_module_names list to include the actual
	// modname.
	PyObject sys = imp.importName("sys", true);
	PyObject names = sys.__findattr__("builtin_module_names");
	if (names == null)
	    names = new PyList();
	
	
	//names = __builtin__.list(names);
	//NKύX
	names = new PyList(names);
	
	((PyList)names).append(new PyString(modname));
	names = __builtin__.tuple(names);
	sys.__setattr__("builtin_module_names", names);

	// Inserted the native posix name in sys.modules
	PyObject module = imp.importName("jnios", true);
        PyObject posix = module.__getattr__("posix");
	sys.__findattr__("modules").__setitem__(modname, posix);

	// Now the original CPython os.py will be properly fooled.
        PyFrame frame = new PyFrame(null, dict, dict, null);
        imp.importAll("cos", frame);
    }
}