
import java.util.*;
import jnios.*;


public class SocketTest2
{

	public static void startConnection()
	{

		Server svr = new Server();
		svr.start();

		try {
			Thread.sleep(1000);
		} catch (Exception e ) {
			e.printStackTrace();
		}


		Client clt = new Client();
		clt.start();
	}


	public static void main(String[] args)
	{
		
		SocketTest st = new SocketTest();
		
		st.startConnection();

	}


}

class Server2 extends Thread
{

	public void run()
	{

		this.startTCPServer();

	}

	public static int startTCPServer()
	{
		int fd, listen_fd;

		byte[] recvBuf = new byte[1024];
		long[] addrArr = new long[10];


		listen_fd = posix.socket("AF_INET", "SOCK_STREAM", "IPPROTO_TCP");
		
		posix.bind(listen_fd, "AF_INET", "127.0.0.1", "8888");
		
		posix.listen(listen_fd, 0);
		
		fd = posix.accept(listen_fd, addrArr);

		while (true)
		{

			posix.recv(fd, recvBuf, 1024, 0);
			
			System.out.println("TCP Server recv buf[0] = " + recvBuf[0] + "\n");
			
			try {
				Thread.sleep(1000);
			} catch (Exception e ) {
				e.printStackTrace();
			}

		}

		//return 0;

	}
}


class Client2 extends Thread
{
	public void run()
	{
		this.startTCPClient();
	}

	public static int startTCPClient()
	{

		byte[] sendBuf = {2, 1, 3, 8, 8, 9, 5, 1};
		
		int fd = posix.socket("AF_INET", "SOCK_STREAM", "IPPROTO_TCP");

		posix.connect( fd, "AF_INET", "127.0.0.1", "8888");

		while ( true)
		{

			posix.send(fd, sendBuf, sendBuf.length, 0);
			
			try {
				Thread.sleep(1000);
			} catch ( Exception e) {
				e.printStackTrace();
			}

		}
		
	}

}


	